diff --git a/cpp/orm_engine/bind.cpp b/cpp/orm_engine/bind.cpp
index c3e0de7579..26c603522e 100644
--- a/cpp/orm_engine/bind.cpp
+++ b/cpp/orm_engine/bind.cpp
@@ -10,9 +10,14 @@
 #include "nb_util.hpp"
 
 #include <algorithm>
+#include <atomic>
 #include <cstdint>
+#include <mutex>
+#include <optional>
 #include <stdexcept>
 #include <string>
+#include <string_view>
+#include <unordered_map>
 #include <utility>
 #include <vector>
 
@@ -20,6 +25,90 @@ namespace nb = nanobind;
 
 namespace {
 
+std::mutex g_simple_compile_cache_mutex;
+std::unordered_map<std::string, std::string> g_simple_compile_cache;
+std::atomic<std::uint64_t> g_simple_compile_cache_hits{0};
+std::atomic<std::uint64_t> g_simple_compile_cache_misses{0};
+
+void append_key_part(std::string& key, std::string_view part) {
+  key += std::to_string(part.size());
+  key += ':';
+  key.append(part);
+  key += '|';
+}
+
+std::string simple_compile_key(
+    char kind, std::uint32_t model_id, int dialect,
+    const std::vector<std::string>& fields, std::string_view lookup,
+    const std::vector<std::string>& ordering, std::uint64_t limit,
+    std::uint64_t offset, bool null_lookup = false) {
+  std::string key;
+  key.reserve(64 + fields.size() * 16 + ordering.size() * 16);
+  key += kind;
+  key += '|';
+  key += std::to_string(
+      django::orm::SchemaRegistry::instance().generation());
+  key += '|';
+  key += std::to_string(model_id);
+  key += '|';
+  key += std::to_string(dialect);
+  key += '|';
+  key += std::to_string(limit);
+  key += '|';
+  key += std::to_string(offset);
+  key += '|';
+  key += null_lookup ? "null|" : "value|";
+  append_key_part(key, lookup);
+  for (const auto& field : fields) {
+    append_key_part(key, field);
+  }
+  key += "#|";
+  for (const auto& item : ordering) {
+    append_key_part(key, item);
+  }
+  return key;
+}
+
+template <typename Builder>
+std::string cached_simple_sql(const std::string& key, Builder&& builder) {
+  {
+    std::lock_guard lock(g_simple_compile_cache_mutex);
+    if (auto it = g_simple_compile_cache.find(key);
+        it != g_simple_compile_cache.end()) {
+      ++g_simple_compile_cache_hits;
+      return it->second;
+    }
+  }
+  std::string sql = builder();
+  if (sql.empty()) {
+    return {};
+  }
+  std::lock_guard lock(g_simple_compile_cache_mutex);
+  auto [it, inserted] = g_simple_compile_cache.emplace(key, std::move(sql));
+  if (inserted) {
+    ++g_simple_compile_cache_misses;
+  } else {
+    ++g_simple_compile_cache_hits;
+  }
+  return it->second;
+}
+
+void clear_simple_compile_cache() {
+  std::lock_guard lock(g_simple_compile_cache_mutex);
+  g_simple_compile_cache.clear();
+  g_simple_compile_cache_hits = 0;
+  g_simple_compile_cache_misses = 0;
+}
+
+std::vector<std::string> strings_from_sequence(nb::sequence values) {
+  std::vector<std::string> out;
+  out.reserve(nb::len(values));
+  for (nb::handle value : values) {
+    out.push_back(nb::cast<std::string>(value));
+  }
+  return out;
+}
+
 django::orm::ParamValue param_from_python(nb::handle h) {
   if (h.is_none()) {
     return django::orm::ParamValue::null();
@@ -43,7 +132,61 @@ django::orm::ParamValue param_from_python(nb::handle h) {
   return django::orm::ParamValue::from_string(nb::cast<std::string>(nb::str(h)));
 }
 
-nb::object param_to_python(const django::orm::ParamValue& p) {
+nb::object postgres_integer_to_python(
+    const django::orm::ParamValue& p, nb::handle integer_types) {
+  using H = django::orm::ParamValue::TypeHint;
+  std::size_t index = 0;
+  switch (p.type_hint) {
+    case H::PostgresInt2:
+      index = 0;
+      break;
+    case H::PostgresInt4:
+      index = 1;
+      break;
+    case H::PostgresInt8:
+      index = 2;
+      break;
+    case H::Default:
+      return nb::int_(p.i);
+  }
+  if (integer_types.is_none()) {
+    return nb::int_(p.i);
+  }
+  if (!nb::isinstance<nb::tuple>(integer_types) || nb::len(integer_types) != 3) {
+    throw nb::type_error("PostgreSQL integer types must be a 3-tuple");
+  }
+  PyObject* type_object = PyTuple_GET_ITEM(integer_types.ptr(), index);
+  if (!PyType_Check(type_object) ||
+      !PyType_IsSubtype(reinterpret_cast<PyTypeObject*>(type_object),
+                        &PyLong_Type)) {
+    throw nb::type_error("PostgreSQL integer adapter must subclass int");
+  }
+
+  // psycopg's Int2/Int4/Int8 are slotless int subclasses whose Python
+  // __new__ methods delegate directly to int.__new__. Call that C slot
+  // ourselves so native preparation doesn't bounce through Python bytecode.
+  PyObject* raw_value = PyLong_FromLongLong(p.i);
+  if (!raw_value) {
+    throw nb::python_error();
+  }
+  PyObject* args = PyTuple_New(1);
+  if (!args) {
+    Py_DECREF(raw_value);
+    throw nb::python_error();
+  }
+  PyTuple_SET_ITEM(args, 0, raw_value);  // Steals raw_value.
+  PyObject* wrapped = PyLong_Type.tp_new(
+      reinterpret_cast<PyTypeObject*>(type_object), args, nullptr);
+  Py_DECREF(args);
+  if (!wrapped) {
+    throw nb::python_error();
+  }
+  return nb::steal<nb::object>(wrapped);
+}
+
+nb::object param_to_python(
+    const django::orm::ParamValue& p,
+    nb::handle postgres_integer_types = nb::none()) {
   using K = django::orm::ParamValue::Kind;
   switch (p.kind) {
     case K::None:
@@ -51,7 +194,7 @@ nb::object param_to_python(const django::orm::ParamValue& p) {
     case K::Bool:
       return nb::bool_(p.b);
     case K::Int:
-      return nb::int_(p.i);
+      return postgres_integer_to_python(p, postgres_integer_types);
     case K::Float:
       return nb::float_(p.f);
     case K::String:
@@ -63,7 +206,368 @@ nb::object param_to_python(const django::orm::ParamValue& p) {
   return nb::none();
 }
 
-nb::tuple compile_to_tuple(const django::orm::QuerySet& self) {
+const django::orm::ModelSchema* registered_model(std::uint32_t model_id) {
+  return django::orm::SchemaRegistry::instance().get(
+      static_cast<django::orm::ModelId>(model_id));
+}
+
+const django::orm::FieldSchema* registered_native_field(
+    const django::orm::ModelSchema& model, std::string_view name) {
+  auto it = model.field_by_name.find(std::string(name));
+  if (it == model.field_by_name.end() || it->second >= model.fields.size()) {
+    return nullptr;
+  }
+  const auto& field = model.fields[it->second];
+  return field.is_native_scalar() ? &field : nullptr;
+}
+
+std::optional<django::orm::ParamValue> direct_param_from_python(
+    nb::handle value, const django::orm::FieldSchema& field,
+    bool allow_null = false) {
+  using django::orm::FieldType;
+  using django::orm::ParamValue;
+
+  if (value.is_none()) {
+    if (allow_null) {
+      return ParamValue::null();
+    }
+    return std::nullopt;
+  }
+
+  const auto integer_value = [&]() -> std::optional<ParamValue> {
+    if (!PyLong_CheckExact(value.ptr())) {
+      return std::nullopt;
+    }
+    int overflow = 0;
+    const long long converted = PyLong_AsLongLongAndOverflow(value.ptr(), &overflow);
+    if (overflow != 0 || PyErr_Occurred()) {
+      PyErr_Clear();
+      return std::nullopt;
+    }
+    ParamValue::TypeHint type_hint = ParamValue::TypeHint::Default;
+    switch (field.type) {
+      case FieldType::SmallInteger:
+        type_hint = ParamValue::TypeHint::PostgresInt2;
+        break;
+      case FieldType::Integer:
+        type_hint = ParamValue::TypeHint::PostgresInt4;
+        break;
+      case FieldType::BigInteger:
+        type_hint = ParamValue::TypeHint::PostgresInt8;
+        break;
+      default:
+        break;
+    }
+    return ParamValue::from_int(
+        static_cast<std::int64_t>(converted), type_hint);
+  };
+
+  switch (field.type) {
+    case FieldType::Integer:
+    case FieldType::BigInteger:
+    case FieldType::SmallInteger:
+    case FieldType::Auto:
+    case FieldType::BigAuto:
+      return integer_value();
+    case FieldType::Float: {
+      if (PyFloat_CheckExact(value.ptr())) {
+        return ParamValue::from_float(PyFloat_AS_DOUBLE(value.ptr()));
+      }
+      auto integer = integer_value();
+      if (!integer) {
+        return std::nullopt;
+      }
+      return ParamValue::from_float(static_cast<double>(integer->i));
+    }
+    case FieldType::Boolean:
+      if (!PyBool_Check(value.ptr())) {
+        return std::nullopt;
+      }
+      return ParamValue::from_bool(value.ptr() == Py_True);
+    case FieldType::Text:
+    case FieldType::Char:
+      if (!PyUnicode_CheckExact(value.ptr())) {
+        return std::nullopt;
+      }
+      return ParamValue::from_string(nb::cast<std::string>(value));
+    default:
+      return std::nullopt;
+  }
+}
+
+struct NativeLookup {
+  const django::orm::FieldSchema* field = nullptr;
+  std::string field_name;
+  std::string lookup = "exact";
+};
+
+std::optional<NativeLookup> registered_native_lookup(
+    const django::orm::ModelSchema& model, std::string_view key) {
+  if (key.empty()) {
+    return std::nullopt;
+  }
+  NativeLookup out;
+  const auto separator = key.find("__");
+  if (separator == std::string_view::npos) {
+    out.field_name = std::string(key);
+  } else {
+    if (key.find("__", separator + 2) != std::string_view::npos) {
+      return std::nullopt;
+    }
+    out.field_name = std::string(key.substr(0, separator));
+    out.lookup = std::string(key.substr(separator + 2));
+    if (out.lookup != "exact" && out.lookup != "gt" &&
+        out.lookup != "gte" && out.lookup != "lt" &&
+        out.lookup != "lte" && out.lookup != "in" &&
+        out.lookup != "isnull") {
+      return std::nullopt;
+    }
+  }
+  if (out.field_name.empty()) {
+    return std::nullopt;
+  }
+  out.field = registered_native_field(model, out.field_name);
+  if (!out.field) {
+    return std::nullopt;
+  }
+  return out;
+}
+
+bool validate_native_projection(
+    const django::orm::ModelSchema& model,
+    const std::vector<std::string>& fields) {
+  if (fields.empty()) {
+    return false;
+  }
+  return std::all_of(fields.begin(), fields.end(), [&](const auto& name) {
+    return name.find("__") == std::string::npos &&
+           registered_native_field(model, name) != nullptr;
+  });
+}
+
+bool validate_native_ordering(
+    const django::orm::ModelSchema& model,
+    const std::vector<std::string>& ordering) {
+  return std::all_of(ordering.begin(), ordering.end(), [&](const auto& item) {
+    std::string_view name(item);
+    if (!name.empty() && name.front() == '-') {
+      name.remove_prefix(1);
+    }
+    return !name.empty() && name != "?" &&
+           name.find("__") == std::string_view::npos &&
+           registered_native_field(model, name) != nullptr;
+  });
+}
+
+std::optional<django::orm::QNode> native_q_node_from_python(
+    const django::orm::ModelSchema& model, nb::handle value,
+    bool negated = false) {
+  if (!nb::isinstance<nb::dict>(value)) {
+    return std::nullopt;
+  }
+  nb::dict tree = nb::cast<nb::dict>(value);
+  if (!tree.contains("kind") || !PyUnicode_CheckExact(tree["kind"].ptr())) {
+    return std::nullopt;
+  }
+  const std::string kind = nb::cast<std::string>(tree["kind"]);
+  django::orm::QNode node;
+  if (kind == "atom") {
+    node.kind = 3;
+    if (!tree.contains("key") || !PyUnicode_CheckExact(tree["key"].ptr()) ||
+        tree.contains("rhs_sql")) {
+      return std::nullopt;
+    }
+    node.key = nb::cast<std::string>(tree["key"]);
+    auto lookup = registered_native_lookup(model, node.key);
+    if (!lookup || (negated && lookup->field->nullable) ||
+        !tree.contains("values")) {
+      return std::nullopt;
+    }
+
+    nb::handle raw_values = tree["values"];
+    const bool sequence = nb::isinstance<nb::list>(raw_values) ||
+                          nb::isinstance<nb::tuple>(raw_values);
+    if (lookup->lookup == "isnull") {
+      if (!sequence || nb::len(raw_values) != 1) {
+        return std::nullopt;
+      }
+      nb::sequence raw_sequence = nb::cast<nb::sequence>(raw_values);
+      nb::handle raw = raw_sequence[0];
+      if (!PyBool_Check(raw.ptr())) {
+        return std::nullopt;
+      }
+      node.values.push_back(
+          django::orm::ParamValue::from_bool(raw.ptr() == Py_True));
+      return node;
+    }
+    if (!sequence) {
+      return std::nullopt;
+    }
+    const std::size_t count = nb::len(raw_values);
+    if ((lookup->lookup == "in" && count == 0) ||
+        (lookup->lookup != "in" && count != 1)) {
+      return std::nullopt;
+    }
+    node.values.reserve(count);
+    nb::sequence raw_sequence = nb::cast<nb::sequence>(raw_values);
+    for (nb::handle raw : raw_sequence) {
+      auto param = direct_param_from_python(raw, *lookup->field);
+      if (!param) {
+        return std::nullopt;
+      }
+      node.values.push_back(std::move(*param));
+    }
+    return node;
+  }
+
+  if (kind == "and") {
+    node.kind = 0;
+  } else if (kind == "or") {
+    node.kind = 1;
+  } else if (kind == "xor") {
+    node.kind = 4;
+  } else if (kind == "not") {
+    node.kind = 2;
+  } else {
+    return std::nullopt;
+  }
+  if (!tree.contains("children")) {
+    return std::nullopt;
+  }
+  nb::handle raw_children = tree["children"];
+  if (!nb::isinstance<nb::list>(raw_children) &&
+      !nb::isinstance<nb::tuple>(raw_children)) {
+    return std::nullopt;
+  }
+  const std::size_t count = nb::len(raw_children);
+  if (count == 0 || (node.kind == 2 && count != 1)) {
+    return std::nullopt;
+  }
+  node.children.reserve(count);
+  nb::sequence children = nb::cast<nb::sequence>(raw_children);
+  for (nb::handle raw : children) {
+    auto child = native_q_node_from_python(
+        model, raw, node.kind == 2 ? !negated : negated);
+    if (!child) {
+      return std::nullopt;
+    }
+    node.children.push_back(std::move(*child));
+  }
+  return node;
+}
+
+std::optional<django::orm::QNode> native_q_node_from_python(
+    std::uint32_t model_id, nb::handle tree) {
+  const auto* model = registered_model(model_id);
+  if (!model) {
+    return std::nullopt;
+  }
+  return native_q_node_from_python(*model, tree);
+}
+
+std::optional<std::vector<django::orm::ParamValue>>
+native_lookup_values_from_python(
+    const django::orm::ModelSchema& model, std::string_view field_name,
+    bool lookup_in, nb::sequence values) {
+  const auto* field = registered_native_field(model, field_name);
+  const std::size_t count = nb::len(values);
+  if (!field || count == 0 || (!lookup_in && count != 1)) {
+    return std::nullopt;
+  }
+  std::vector<django::orm::ParamValue> out;
+  out.reserve(count);
+  for (nb::handle raw : values) {
+    auto param = direct_param_from_python(raw, *field);
+    if (!param) {
+      return std::nullopt;
+    }
+    out.push_back(std::move(*param));
+  }
+  return out;
+}
+
+struct NativeUpdate {
+  std::string name;
+  django::orm::ParamValue value;
+  bool set_null = false;
+};
+
+std::optional<std::vector<NativeUpdate>> native_updates_from_python(
+    const django::orm::ModelSchema& model, nb::dict updates) {
+  if (nb::len(updates) == 0) {
+    return std::nullopt;
+  }
+  std::vector<NativeUpdate> out;
+  out.reserve(nb::len(updates));
+  for (auto item : updates) {
+    if (!PyUnicode_CheckExact(item.first.ptr())) {
+      return std::nullopt;
+    }
+    NativeUpdate update;
+    update.name = nb::cast<std::string>(item.first);
+    if (update.name.find("__") != std::string::npos) {
+      return std::nullopt;
+    }
+    const auto* field = registered_native_field(model, update.name);
+    if (!field) {
+      return std::nullopt;
+    }
+    update.set_null = item.second.is_none();
+    auto param = direct_param_from_python(
+        item.second, *field, update.set_null && field->nullable);
+    if (!param) {
+      return std::nullopt;
+    }
+    update.value = std::move(*param);
+    out.push_back(std::move(update));
+  }
+  return out;
+}
+
+std::optional<std::vector<NativeUpdate>> native_updates_from_python(
+    const django::orm::ModelSchema& model,
+    const std::vector<std::string>& names, nb::sequence values) {
+  if (names.empty() || names.size() != nb::len(values)) {
+    return std::nullopt;
+  }
+  std::vector<NativeUpdate> out;
+  out.reserve(names.size());
+  std::size_t index = 0;
+  for (nb::handle raw : values) {
+    NativeUpdate update;
+    update.name = names[index++];
+    if (update.name.find("__") != std::string::npos) {
+      return std::nullopt;
+    }
+    const auto* field = registered_native_field(model, update.name);
+    if (!field) {
+      return std::nullopt;
+    }
+    update.set_null = raw.is_none();
+    auto param = direct_param_from_python(
+        raw, *field, update.set_null && field->nullable);
+    if (!param) {
+      return std::nullopt;
+    }
+    update.value = std::move(*param);
+    out.push_back(std::move(update));
+  }
+  return out;
+}
+
+std::vector<std::string> update_cache_fields(
+    const std::vector<NativeUpdate>& updates) {
+  std::vector<std::string> out;
+  out.reserve(updates.size());
+  for (const auto& update : updates) {
+    out.push_back(update.name + (update.set_null ? "#null" : "#value"));
+  }
+  return out;
+}
+
+nb::tuple compile_to_tuple(
+    const django::orm::QuerySet& self,
+    nb::handle postgres_integer_types = nb::none()) {
   auto compiled = self.compile();
   nb::list params;
   const auto& q = self.query();
@@ -71,7 +575,7 @@ nb::tuple compile_to_tuple(const django::orm::QuerySet& self) {
     if (idx >= q.params.size()) {
       throw std::runtime_error("param index out of range");
     }
-    params.append(param_to_python(q.params[idx]));
+    params.append(param_to_python(q.params[idx], postgres_integer_types));
   }
   return nb::make_tuple(nb::str(compiled.sql.c_str(), compiled.sql.size()), params);
 }
@@ -127,22 +631,77 @@ django::orm::QNode q_node_from_python(nb::handle h) {
   return node;
 }
 
+nb::dict q_node_to_python(const django::orm::QNode& node) {
+  nb::dict out;
+  if (node.kind == 3) {
+    out["kind"] = "atom";
+    out["key"] = node.key;
+    nb::list values;
+    for (const auto& value : node.values) {
+      values.append(param_to_python(value));
+    }
+    out["values"] = values;
+    if (node.has_rhs_sql) {
+      out["rhs_sql"] = node.rhs_sql;
+      out["rhs_op"] = node.rhs_op;
+      nb::list params;
+      for (const auto& value : node.rhs_params) {
+        params.append(param_to_python(value));
+      }
+      out["rhs_params"] = params;
+    }
+    return out;
+  }
+
+  const char* kind = "and";
+  if (node.kind == 1) {
+    kind = "or";
+  } else if (node.kind == 2) {
+    kind = "not";
+  } else if (node.kind == 4) {
+    kind = "xor";
+  }
+  out["kind"] = kind;
+  nb::list children;
+  for (const auto& child : node.children) {
+    children.append(q_node_to_python(child));
+  }
+  out["children"] = children;
+  return out;
+}
+
 }  // namespace
 
 void register_orm_engine(nb::module_& parent) {
   nb::module_ m = parent.def_submodule("orm", "Native ORM data plane");
 
-  m.def("clear_schema",
-        []() { django::orm::SchemaRegistry::instance().clear(); });
+  m.def("clear_schema", []() {
+    django::orm::SchemaRegistry::instance().clear();
+    clear_simple_compile_cache();
+  });
+
+  m.def(
+      "simple_compile_cache_info",
+      []() {
+        nb::dict out;
+        std::lock_guard lock(g_simple_compile_cache_mutex);
+        out["size"] = g_simple_compile_cache.size();
+        out["hits"] = g_simple_compile_cache_hits.load();
+        out["misses"] = g_simple_compile_cache_misses.load();
+        return out;
+      });
+
+  m.def("clear_simple_compile_cache", &clear_simple_compile_cache);
 
   m.def(
       "register_model",
       [](const std::string& label, const std::string& db_table, nb::list fields) {
-        // fields tuple (min 6, full 14):
+        // fields tuple (min 6, full 16):
         // 0 name, 1 attname, 2 column, 3 class_name, 4 pk, 5 null,
         // 6 remote_table, 7 remote_pk, 8 remote_label,
         // 9 rel_kind ("fk"|"rev_fk"|"m2m"|"rev_m2m"|""),
-        // 10 m2m_table, 11 m2m_column, 12 m2m_reverse_column, 13 remote_fk_column
+        // 10 m2m_table, 11 m2m_column, 12 m2m_reverse_column,
+        // 13 remote_fk_column, 14 native_direct, 15 generated.
         django::orm::ModelSchema schema;
         schema.label = label;
         schema.db_table = db_table;
@@ -175,8 +734,20 @@ void register_orm_engine(nb::module_& parent) {
           if (n >= 14) {
             f.remote_fk_column = nb::cast<std::string>(t[13]);
           }
+          if (n >= 15) {
+            f.native_direct = nb::cast<bool>(t[14]);
+          } else {
+            // Compatibility for the low-level test/debug surface. Production
+            // schema exports always send the explicit exact-class bit.
+            f.native_direct =
+                django::orm::field_type_has_direct_primitive_prep(f.type);
+          }
+          if (n >= 16) {
+            f.generated = nb::cast<bool>(t[15]);
+          }
           if (f.rel != django::orm::RelKind::None) {
             f.type = django::orm::FieldType::ForeignKey;
+            f.native_direct = false;
           }
           schema.fields.push_back(std::move(f));
         }
